WPS4Graph Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
WPS4Graph Class Reference

the main class to read/store picture in a Pc MS Works document v1-4 More...

`#include <WPS4Graph.h>`

## Public Member Functions
| WPS4Graph (WPS4Parser &parser)
| constructor given the main parser of the MN0 zone More...
| ~WPS4Graph ()
| destructor More...
void | setListener (WPSContentListenerPtr &listen)
| sets the listener More...
void | computePositions () const
| computes the position of all found figures. More...
int | numPages () const
| returns the number page where we find a picture. In practice, 0/1 More...

## Protected Member Functions
int | version () const
| returns the file version More...
void | storeObjects (std::vector< WPSOLEParserObject > const &objects, std::vector< int > const &ids)
| store a list of object More...
int | readObject (RVNGInputStreamPtr input, WPSEntry const &entry)
| tries to find a picture in the zone pointed by entry More...
void | sendObject (Vec2f const &size, int id)
| sends an object with identificator id as a character with given size More...
void | sendObjects (int page)
| send all the objects of a given page: More...
libwps::DebugFile & | ascii ()
| returns the debug file More...

## Protected Attributes
WPSContentListenerPtr | m_listener
| the listener More...
WPS4Parser & | m_mainParser
| the main parser More...
shared_ptr< WPS4GraphInternal::State > | m_state
| the state More...
libwps::DebugFile & | m_asciiFile
| the ascii file More...

## Private Member Functions
| WPS4Graph (WPS4Graph const &orig)
WPS4Graph & | operator= (WPS4Graph const &orig)

## Friends
class | WPS4Parser

## Detailed Description

the main class to read/store picture in a Pc MS Works document v1-4

This class must be associated with a WPS4Parser.

Note
  As the pictures seems always be given with character' position, many functions which exists to maintain the same structures that exist(will) in WPS8TextGraph class do almost nothing.

## Constructor & Destructor Documentation

WPS4Graph::WPS4Graph | ( | WPS4Parser & | parser | ) |
| explicit

constructor given the main parser of the MN0 zone

WPS4Graph::~WPS4Graph | ( |  | ) |

destructor

WPS4Graph::WPS4Graph | ( | WPS4Graph const & | orig | ) |
| private

## Member Function Documentation

libwps::DebugFile& WPS4Graph::ascii | ( |  | ) |
| inlineprotected

returns the debug file

Referenced by readObject().

void WPS4Graph::computePositions | ( |  | ) | const

computes the position of all found figures.

In reality, as all the pictures seemed to be given with characters positions, it does almost nothing, ie it only updates some internal bool to know the picture which have been sent to the listener.

int WPS4Graph::numPages | ( |  | ) | const

returns the number page where we find a picture. In practice, 0/1

WPS4Graph& WPS4Graph::operator= | ( | WPS4Graph const & | orig | ) |
| private

int WPS4Graph::readObject | ( | RVNGInputStreamPtr | input,
|  | WPSEntry const & | entry
| ) |  |
| protected

tries to find a picture in the zone pointed by entry

Returns
  the object id or -1 if find nothing

Note
  the content of this zone is mainly unknown, so this function may failed to retrieved valid data

void WPS4Graph::sendObject | ( | Vec2f const & | size,
|  | int | id
| ) |  |
| protected

sends an object with identificator id as a character with given size

void WPS4Graph::sendObjects | ( | int | page | ) |
| protected

send all the objects of a given page:

Parameters

  page | if page < 0, sends all the pictures which have not been used,

As all the pictures seemed to be given with characters positions, this function only does something if page < 0.

void WPS4Graph::setListener | ( | WPSContentListenerPtr & | listen | ) |
| inline

sets the listener

void WPS4Graph::storeObjects | ( | std::vector< WPSOLEParserObject > const & | objects,
|  | std::vector< int > const & | ids
| ) |  |
| protected

store a list of object

int WPS4Graph::version | ( |  | ) | const
| protected

returns the file version

## Friends And Related Function Documentation

friend class WPS4Parser
| friend

## Member Data Documentation

libwps::DebugFile& WPS4Graph::m_asciiFile
| protected

the ascii file

WPSContentListenerPtr WPS4Graph::m_listener
| protected

the listener

Referenced by sendObject(), and sendObjects().

WPS4Parser& WPS4Graph::m_mainParser
| protected

the main parser

Referenced by version().

shared_ptr<WPS4GraphInternal::State> WPS4Graph::m_state
| mutableprotected

the state

Referenced by computePositions(), numPages(), readObject(), sendObject(), sendObjects(), storeObjects(), and version().

The documentation for this class was generated from the following files:

- WPS4Graph.h
- WPS4Graph.cpp